<?php

declare(strict_types=1);

namespace App\Repository;

final class TblPublicidadRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblPublicidadId): object
    {
        $query = 'SELECT * FROM `TblPublicidad` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPublicidadId);
        $statement->execute();
        $TblPublicidad = $statement->fetchObject();
        if (! $TblPublicidad) {
            throw new \Exception('TblPublicidad not found.', 404);
        }

        return $TblPublicidad;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblPublicidad` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblPublicidad): object
    {
        $query = 'INSERT INTO `TblPublicidad` (`ImagenPub`, `ImagenPerfil`, `Grupo`, `Orden`, `IdCurso`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:ImagenPub, :ImagenPerfil, :Grupo, :Orden, :IdCurso, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblPublicidad->id);
//         $statement->bindParam('fecha', $TblPublicidad->fecha);
        $statement->bindParam('ImagenPub', $TblPublicidad->ImagenPub);
        $statement->bindParam('ImagenPerfil', $TblPublicidad->ImagenPerfil);
        $statement->bindParam('Grupo', $TblPublicidad->Grupo);
        $statement->bindParam('Orden', $TblPublicidad->Orden);
        $statement->bindParam('IdCurso', $TblPublicidad->IdCurso);
        $statement->bindParam('field1', $TblPublicidad->field1);
        $statement->bindParam('field2', $TblPublicidad->field2);
        $statement->bindParam('field3', $TblPublicidad->field3);
        $statement->bindParam('field4', $TblPublicidad->field4);
        $statement->bindParam('field5', $TblPublicidad->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblPublicidad, object $data): object
    {
        if (isset($data->fecha)) {
            $TblPublicidad->fecha = $data->fecha;
        }
        if (isset($data->ImagenPub)) {
            $TblPublicidad->ImagenPub = $data->ImagenPub;
        }
        if (isset($data->ImagenPerfil)) {
            $TblPublicidad->ImagenPerfil = $data->ImagenPerfil;
        }
        if (isset($data->Grupo)) {
            $TblPublicidad->Grupo = $data->Grupo;
        }
        if (isset($data->Orden)) {
            $TblPublicidad->Orden = $data->Orden;
        }
        if (isset($data->IdCurso)) {
            $TblPublicidad->IdCurso = $data->IdCurso;
        }
        if (isset($data->field1)) {
            $TblPublicidad->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblPublicidad->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblPublicidad->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblPublicidad->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblPublicidad->field5 = $data->field5;
        }

        $query = 'UPDATE `TblPublicidad` SET `fecha` = :fecha, `ImagenPub` = :ImagenPub, `ImagenPerfil` = :ImagenPerfil, `Grupo` = :Grupo, `Orden` = :Orden, `IdCurso` = :IdCurso, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPublicidad->id);
        $statement->bindParam('fecha', $TblPublicidad->fecha);
        $statement->bindParam('ImagenPub', $TblPublicidad->ImagenPub);
        $statement->bindParam('ImagenPerfil', $TblPublicidad->ImagenPerfil);
        $statement->bindParam('Grupo', $TblPublicidad->Grupo);
        $statement->bindParam('Orden', $TblPublicidad->Orden);
        $statement->bindParam('IdCurso', $TblPublicidad->IdCurso);
        $statement->bindParam('field1', $TblPublicidad->field1);
        $statement->bindParam('field2', $TblPublicidad->field2);
        $statement->bindParam('field3', $TblPublicidad->field3);
        $statement->bindParam('field4', $TblPublicidad->field4);
        $statement->bindParam('field5', $TblPublicidad->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblPublicidad->id);
    }

    public function delete(int $TblPublicidadId): void
    {
        $query = 'DELETE FROM `TblPublicidad` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPublicidadId);
        $statement->execute();
    }
}
